#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);
const int size = 500 * 1000;
const int alph = 26;

int ways[size][alph];
int link[size];
int maxlen[size];
int asize;
int lst;
int n, k;
char str[size];

int nod(int a, int b) {
	if (b == 0)
		return a;
	else
		return nod(b, a % b);
}

void addsmb(int c) {
	int nlst = asize++;
	int p = lst;
	maxlen[nlst] = maxlen[lst] + 1;
	while (p != -1 && ways[p][c] == 0) {
		ways[p][c] = nlst;
		p = link[p];
	}
	if (p == -1) {
		link[nlst] = 0;
	} else if (maxlen[ways[p][c]] == maxlen[p] + 1) {
		link[nlst] = ways[p][c];
	} else {
		int cp = ways[p][c];
		int clone = asize++;
		for (int i = 0; i < alph; i++)
			ways[clone][i] = ways[cp][i];
	   	link[clone] = link[cp];
	   	maxlen[clone] = maxlen[p] + 1;
	   	link[cp] = clone;
	   	link[nlst] = clone;
	   	while (p != -1 && ways[p][c] == cp) {
	   		ways[p][c] = clone;
	   		p = link[p];
	   	}
	}

	lst = nlst;
}

void getminshift(string& s, string& shift) {
	int n = s.size();
	for (int i = 0; i < asize; i++) {
		for (int j = 0; j < alph; j++) {
			ways[i][j] = 0;
		}
		link[i] = 0;
		maxlen[i] = 0;
	}
	asize = 1;
	lst = 0;
	link[0] = -1;
	for (int i = 0; i < n; i++)
		addsmb(s[i] - 'a');
	for (int i = 0; i < n; i++)
		addsmb(s[i] - 'a');
	shift.clear();
	int p = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < alph; j++)
			if (ways[p][j] != 0) {
				shift += char('a' + j);
				p = ways[p][j];
				break;
			}
	}
}

void pushallcyclic(string s, string& shift, vector <int>& minshifts) {
	getminshift(s, shift);
	int n = s.size();
	string res = shift + s + s;
	vector <int> z(res.size());
	int b = 0;
	for (int i = 0; i < (int) res.size(); i++) {
		z[i] = max(0, min(z[i - b], b + z[b]) - 1);
		while (i + z[i] < (int) res.size() && res[i + z[i]] == res[z[i]])
			z[i]++;
		if (i + z[i] > b + z[b])
			b = i;
		if (z[i] >= n && i >= n && i < 2 * n)
			minshifts.pb(i - n);
	}
}

vector <int> allshifts[size];
string minshift[size];

int main() {
//    freopen("games.in", "r", stdin);
//    freopen("games.out", "w", stdout);

    scanf("%d%d", &n, &k);
    scanf("%s", str);

    k = (k % n + n) % n;
    int d = nod(n, k);
    int len = n / d;

    vector <int> ans;
    string sans;
    sans += char('z' + 1);

    for (int i = 0; i < d; i++) {
    	string s;
    	int p = i;
    	for (int j = 0; j < len; j++) {
    		s += str[p];
    		p = (p + k) % n;
    	}
    	pushallcyclic(s, minshift[i], allshifts[i]);
    	sans = min(sans, minshift[i]);
    }
    for (int i = 0; i < d; i++)
    	if (minshift[i] == sans) {
    		for (int j = 0; j < (int) allshifts[i].size(); j++)
    			ans.pb(int((i + k * 1ll * allshifts[i][j]) % n));
    	}
    if (ans.size() == 1u) {
    	printf("Finite\n");
    } else {
    	printf("Infinite\n");
    }

    sort(ans.begin(), ans.end());

    for (int i = 0; i < (int) ans.size(); i++)
    	printf("%d%c", ans[i] + 1, " \n"[i == (int) ans.size() - 1]); 


    return 0;
}