#include <cstdio>
#include <set>
#include <cassert>
#include "testlib.h"
using namespace std;

const int N = 10;
const int K = 38;
const int NN = N * N;
const int MAXT = 10000;

struct vt
{
    int y, x;
    vt()
    {
        y = x = 0;
    }
    vt(int _y, int _x)
    {
        y = _y, x = _x;
    }
    friend vt operator +(vt a, vt b)
    {
        return vt(a.y + b.y, a.x + b.x);
    }
    friend bool operator <(vt a, vt b)
    {
        return a.y * NN + a.x < b.y * NN + b.x;
    }
};

vt Q[NN];
int lpt = 0, rpt = 0;

set<vt> S;

vt pop_back()
{
    vt res = Q[lpt++];
    assert(S.erase(res) == 1);
    if (lpt == NN)
        lpt = 0;
    return res;
}

int turn = 0;

void push_front(vt v)
{
    if (S.find(v) != S.end())
        quit(_wa, format("turn %d: cell (%d %d) is twice in the snake!\n", turn, v.y, v.x)); 
    Q[rpt++] = v;
    if (rpt == NN)
        rpt = 0;
    assert(S.insert(v).second);
}

void push_back(vt v)
{
    if (S.find(v) != S.end())
        quit(_wa, format("turn %d: cell (%d %d) is twice in the snake!\n", turn, v.y, v.x));
    if (lpt == 0)
        lpt = NN;
    Q[--lpt] = v;
    assert(S.insert(v).second);
}

vt front()
{
    if (rpt == 0)
        return Q[NN - 1];
    else
        return Q[rpt - 1];
}

vt A[K];
int apt = 0;

vt d[256];

int main(int argc, char *argv[])
{
    d['R'] = vt(0, 1);
    d['U'] = vt(-1, 0);
    d['L'] = vt(0, -1);
    d['D'] = vt(1, 0);

    registerTestlibCmd(argc, argv);
    int n = N;
    int m = N;
    int k = inf.readInt();
    for (int i = 0; i < k; i++)
    {
        A[i].y = inf.readInt();
        A[i].x = inf.readInt();
    }
    push_front(vt(1, 1));
    push_front(vt(1, 2));
    push_front(vt(1, 3));
    int T = ouf.readInt(0, MAXT);
    ouf.readEoln();
    string G = ouf.readString("[RLUD]{" + vtos(T) + "}");
    for (int i = 0; i < G.size(); i++)
    {
        ++turn;
        vt h = front();
        vt t = pop_back();
        vt q = h + d[G[i]];
        quitif(q.x < 1 || q.y < 1 || q.x > m || q.y > n, _wa, "turn %d: snake's head (%d %d) is out of the field", turn, q.y, q.x);
        push_front(h + d[G[i]]);
        if (apt != k && S.find(A[apt]) != S.end())
            apt++, push_back(t);
    }
    quitf(_ok, "ate all apples in %d turns\n", turn);
}
